{
This is the license for the Minds In Motion 90-day trial products.  Read this
 license and  if  you do not agree destory this and all other related files immediately.

 Minds In Motion

 CAUTION: Loading this software onto a computer indicates your acceptance of
 the following terms.  Please read them carefully.

 TRIAL LICENSE: Minds In Motion  grants you a no-charge
 trial license to use the software selected ("Software") solely for
 evaluation purposes for a period of 90 days.  You may not use the
 Software for any development, commercial, or production purpose.  You
 may give trial copies of the Software to others to permit them to use
 the Software under the same restrictions as are in this Agreement,
 provided that you do not charge a fee for doing so.  You must purchase
 a full-use license if you wish to do any of the following: (a) use
 the Software after the end of the 90-day trial period, or (b) use the
 Software for any development, commercial, or production purpose, or
 (c) distribute the Software for any such use.

 COPYRIGHT: The Software is the proprietary product of Minds In Motion and is
 protected by copyright law.  You acquire only the right to use the
 Software and do not acquire any rights of ownership.  You agree not
 to remove any product identification, copyright notices, or other
 notices or proprietary restrictions from the Software.  You agree not
 to cause or permit the reverse engineering, disassembly, or
 decompilation of the Software.  You shall not disclose the results of
 any benchmark tests of the Software to any third party without
 Minds In Motion's prior written approval.

 WARRANTY DISCLAIMER: Minds In Motion is providing this license on an "as is"
 basis without warranty of any kind.  Minds In Motion disclaims all express and
 implied warranties, including the implied warranties of
 merchantability or fitness for a particular purpose.

 LIMITATION OF LIABILITY: Minds In Motion SHALL NOT BE LIABLE FOR ANY DAMAGES,
 INCLUDING DIRECT, INDIRECT, INCIDENTAL, SPECIAL OR CONSEQUENTIAL
 DAMAGES, OR DAMAGES FOR LOSS OF PROFITS, REVENUE, DATA OR DATA USE,
 INCURRED BY YOU OR ANY THIRD PARTY, WHETHER IN AN ACTION IN CONTRACT
 OR TORT, EVEN IF YOU OR ANY OTHER PERSON HAS BEEN ADVISED OF THE
 POSSIBILITY OF SUCH DAMAGES.

 EXPORT: You agree to comply fully with all laws and regulations to
 assure that neither the Software, nor any direct product thereof, is
 exported, directly or indirectly, in violation of law.

 RESTRICTED RIGHTS: If the Software is used by a U.S. Government Agency
 of the Department of Defense, then the use is with Restricted Rights
 and the following legend is applicable:  "Restricted Rights Legend
 Use, duplication or disclosure by the Government is subject to
 restrictions as currently set forth in subparagraph (c)(1)(ii) of
 DFARS 252-227-7013, Rights in Technical Data and Computer Software
 (October  1988). Minds In Motion , 25041 Rivendell Dr, Lake Forest CA 92630.
 If the Software is used by a U.S. Government Agency
 not within the Department of Defense, then the use is with "Restricted
 Rights" as defined in FAR 52.227-14, Rights in Data - General,
 including Alternate III (June 1987)."
}

unit Odbctest;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, ExtCtrls, StdCtrls, ODBC, ODBCDecl, OdbcTes2;

type
  TForm1 = class(TForm)
    cmdNext: TButton;
    cmdPrev: TButton;
    cmdGoto: TButton;
    cmdAdd: TButton;
    cmdDelete: TButton;
    cmdMod: TButton;
    Label1: TLabel;
    edtName: TEdit;
    Label2: TLabel;
    edtAge: TEdit;
    Label3: TLabel;
    edtRec: TEdit;
    cmdLoadBmp: TButton;
    OpenDialog1: TOpenDialog;
    cmdConnect: TButton;
    cmdDisconnect: TButton;
    Panel1: TPanel;
    imgPicture: TImage;
    cmdRequery: TButton;
    cmdViewAll: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure cmdLoadBmpClick(Sender: TObject);
    procedure cmdConnectClick(Sender: TObject);
    procedure cmdDisconnectClick(Sender: TObject);
    procedure cmdRequeryClick(Sender: TObject);
    procedure cmdAddClick(Sender: TObject);
    procedure cmdNextClick(Sender: TObject);
    procedure cmdModClick(Sender: TObject);
    procedure cmdPrevClick(Sender: TObject);
    procedure cmdGotoClick(Sender: TObject);
    procedure cmdDeleteClick(Sender: TObject);
    procedure cmdViewAllClick(Sender: TObject);
  private
		fStillConnected:	boolean;
     nRecCount:			integer;
		szSearchName:		array [0..255] of char;
  	nSearchAge:			integer;

    { Private declarations }
		procedure SaveScreenData;
		procedure RestoreScreenData;
     procedure ClearScreenData;
		procedure DisconnectDataSource;
     function Trim(strIn: string): string;
  public
    { Public declarations }
  end;

var
  Form1: 		TForm1;
  strPicFile:	string;
  mydb:      	TOdbcConnection;
 	strOut:    	String;
	nOut:			SWORD;
	ds:			TOdbcDynaset;

implementation

{$R *.DFM}

const
	strTempFile = '~pic.bmp';
function TForm1.Trim(strIn: string): string;
var
	strTemp:	string;
  i:			integer;
begin
	strTemp := '';
	for i := 1 to length(strIn) do
  	if strIn[i] <> ' ' then
     	strTemp := strTemp + strIn[i];

	Trim := strTemp;
end;

procedure TForm1.ClearScreenData;
begin
  edtName.text := '';
  edtAge.text := '';
	imgPicture.picture := nil;
end;

procedure TForm1.SaveScreenData;
var
	nage, ncode:	integer;
begin
  ds.Field[0].AsString := edtName.text;
  val(edtAge.text,nage,ncode);
  ds.Field[1].AsInteger := nage;
	ds.Field[2].LoadFromFile(strPicFile);
end;

procedure TForm1.RestoreScreenData;
begin
  edtName.text := ds.field[0].AsString;
  edtAge.text := ds.field[1].AsString;
  ds.field[2].savetofile(strTempFile);
	imgPicture.picture.loadfromfile(strTempFile);
  strPicFile := strTempFile;
end;

procedure TForm1.DisconnectDataSource;
begin
	mydb.ReleaseDynaset(ds);
	mydb.Destroy;
 	MessageDlg('Disconnected the data source!', mtInformation, [mbOK],0);
  fStillConnected := false;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
	odbc.Initialize;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
	if fStillConnected then
  	DisconnectDataSource;

	odbc.Terminate;
end;

procedure TForm1.cmdLoadBmpClick(Sender: TObject);
begin
  OpenDialog1.FileName := '*.bmp';
  OpenDialog1.DefaultExt := 'bmp';
  OpenDialog1.Filter := 'All files (*.*)|*.*|Bitmaps (*.bmp)|*.bmp';
  if OpenDialog1.Execute then begin
    strPicFile := OpenDialog1.FileName;
	  imgPicture.picture.loadfromfile(strPicFile);
  end
  else
	  strPicFile := '';
end;

procedure TForm1.cmdConnectClick(Sender: TObject);
begin
  mydb := TOdbcConnection.Init;
	mydb.DriverConnect(Handle, '', strOut, nOut, SQL_DRIVER_COMPLETE);
	if mydb.errorState = '100' then begin
  	messagedlg('Driver NOT connected!',
    					mtInformation, [mbOK], 0);
		mydb.Destroy;
     exit;
  end;
  mydb.AutoCommit := false;
  
	ds := mydb.CreateDynaset;
  {ds.AutoGetBlob := false;}

  ds.ClearParams;	{not really necessary...}
 	ds.AddParam(@szSearchName, odbcParamPChar, odbcParamInput);
	{ds.AddParam(@nSearchAge, odbcParamInteger, odbcParamInput);}
	MessageDlg('Connected the data source!', mtInformation, [mbOK],0);
  fStillConnected := true;
  nRecCount := 0;

  cmdConnect.enabled := false;
  cmdDisconnect.enabled := true;
  cmdViewAll.enabled := true;
  cmdRequery.enabled := true;
end;

procedure TForm1.cmdDisconnectClick(Sender: TObject);
begin
	ClearScreenData;
	if fStillConnected then
		DisconnectDataSource
  else
	  MessageDlg('Data source already disconnected!', mtInformation, [mbOK],0);

  cmdConnect.enabled := true;
  cmdDisconnect.enabled := false;
  cmdViewAll.enabled := false;
  cmdRequery.enabled := false;
  cmdNext.enabled := false;
  cmdPrev.enabled := false;
  cmdGoto.enabled := false;
  cmdAdd.enabled := false;
  cmdDelete.enabled := false;
  cmdMod.enabled := false;
end;

procedure TForm1.cmdRequeryClick(Sender: TObject);
var
	strName:		string;
  stat:			ODBCSTATUS;
begin
	strName := trim(edtName.text);
	if strName = '' then
  	strcopy(szSearchName, '%')
  else begin
  	strName := strName + '%';
		strpcopy(szSearchName, strName)
  end;

	stat := ds.Execute('select name, age, picture from odbctest where name like ? order by name');
  if stat <> odbcSuccess then
		MessageDlg('Execute failed with error: ' + ds.errorMsg,
     	mtInformation, [mbOK],0);
	(*
  nSearchAge := 20;
	ds.Execute('select name, age, picture from odbctest where age <= ? order by name');
  *)

  cmdAdd.enabled := true;
  cmdDelete.enabled := true;
  cmdMod.enabled := true;

  if ds.Empty then begin
  	MessageDlg('Table is empty!', mtInformation, [mbOK],0);
  	cmdNext.enabled := false;
  	cmdPrev.enabled := false;
  	cmdGoto.enabled := false;
  end
  else begin
	 	MessageDlg('Result set available!', mtInformation, [mbOK],0);
  	cmdNext.enabled := true;
  	cmdPrev.enabled := true;
  	cmdGoto.enabled := true;
  end;

  ClearScreenData;
end;

procedure TForm1.cmdAddClick(Sender: TObject);
begin
	ds.addnew;
  SaveScreenData;

  ds.update;
end;

procedure TForm1.cmdNextClick(Sender: TObject);
begin
	ds.movenext;
  if ds.eof then begin
  	messagedlg('End of result set!', mtInformation, [mbOK], 0);
     exit;
  end;
  RestoreScreenData;
end;

procedure TForm1.cmdModClick(Sender: TObject);
begin
	ds.edit;
  SaveScreenData;
  ds.update;
end;

procedure TForm1.cmdPrevClick(Sender: TObject);
begin
	ds.moveprevious;
  if ds.bof then begin
  	messagedlg('Start of result set!', mtInformation, [mbOK], 0);
     exit;
  end;
  RestoreScreenData;
end;

procedure TForm1.cmdGotoClick(Sender: TObject);
var
	nrec, ncode:	integer;
begin
	ClearScreenData;
  val(edtRec.text,nrec,ncode);
  if ds.MoveAbsolute(nrec) <> odbcSuccess then begin
  	messagedlg('Could not position on record because!',
     				mtInformation, [mbOK], 0);
     exit;
  end;
  RestoreScreenData;
end;

procedure TForm1.cmdDeleteClick(Sender: TObject);
var
	stat:	ODBCSTATUS;
begin
	stat := ds.delete;
  if stat <> odbcSuccess then
		messagedlg('Error while trying delete. The error was:'+#10#13+ds.errorMsg,
     				mtInformation, [mbOK], 0)
  else
  	ClearScreenData;
end;

procedure TForm1.cmdViewAllClick(Sender: TObject);
var
	ss:	TOdbcSnapshot;
begin
	Form2.ListBox1.Clear;
  ss := mydb.CreateSnapshot;
  ss.Execute('select name from odbctest order by name');
  while ss.MoveNext = odbcSuccess do begin
  	Form2.ListBox1.items.add(ss.Field[0].AsString);
	end;
	mydb.ReleaseSnapshot(ss);
	Form2.show;
end;

end.
